﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ImageEditor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        System.Windows.Forms.ImageList ImageList1;
        string[] items;

        // Function to create DataTable
        public DataTable GetTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("ImageColumn");
            DataRow dr;
            for (int count = 1; count <= 6; count++)
            {
                dr = dt.NewRow();
                dr.ItemArray = new object[] { count };
                dt.Rows.Add(dr);
            }
            return dt;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            // Binding TrueDbGrid to a DataTable at runtime
            DataTable dt = GetTable();
            c1TrueDBGrid1.SetDataBinding(dt, "", false);

            ImageList1 = new ImageList();
            ImageList1.ImageSize = new Size(112, 112);

            // Populating ImageList
            string[] filePaths = Directory.GetFiles(@"..\..\Images\");
            for (int index = 0; index < filePaths.Length; index++)
            {
                ImageList1.Images.Add(Image.FromFile(filePaths[index]));
            }
            // Adjusting RowHeight
            c1TrueDBGrid1.RowHeight = c1TrueDBGrid1.RowHeight * 3;

            // Populating C1Combo
            items = new string[this.ImageList1.Images.Count];
            for (int index = 0; index <= this.ImageList1.Images.Count - 1; index++)
                items[index] = "Item " + index.ToString();
            c1Combo1.DataSource = items;

            // Setting C1Combo properties
            c1Combo1.ItemHeight = 50;
            c1Combo1.Splits[0].ColumnCaptionHeight = 1;
            c1Combo1.AutoCompletion = true;
            c1Combo1.LimitToList = true;

            // Setting C1Combo as Editor of C1TrueDbGrid's Column
            c1TrueDBGrid1.Columns[1].Editor = c1Combo1;

            // To fire FetchStyle event for Grid's DisplayColumn and ComboBox's column.
            c1TrueDBGrid1.Splits[0].DisplayColumns[1].FetchStyle = true;
            c1Combo1.Splits[0].DisplayColumns[0].FetchStyle = true;

            c1TrueDBGrid1.FetchCellStyle += new C1.Win.C1TrueDBGrid.FetchCellStyleEventHandler(c1TrueDBGrid1_FetchCellStyle);
            c1Combo1.FetchCellStyle += new C1.Win.C1List.FetchCellStyleEventHandler(c1Combo1_FetchCellStyle);

        }
        void c1Combo1_FetchCellStyle(object sender, C1.Win.C1List.FetchCellStyleEventArgs e)
        {
            // To map images in C1Combo's Column
            e.CellStyle.ForegroundImage = ImageList1.Images[e.Row];
        }
        void c1TrueDBGrid1_FetchCellStyle(object sender, C1.Win.C1TrueDBGrid.FetchCellStyleEventArgs e)
        {
            var cellText = c1TrueDBGrid1[e.Row, e.Col];
            if (cellText.ToString() == "")
            {
                // To map image in C1TrueDbGrid's Cell
                e.CellStyle.ForegroundImage = ImageList1.Images[e.Row];
            }
            else
            {
                // To change image in C1TrueDbGrid's Cell after selecting from given image editor
                int editorRowIndex = items.ToList().IndexOf(cellText.ToString());
                e.CellStyle.ForegroundImage = ImageList1.Images[editorRowIndex];
            }
        }
    }
}
